"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ThemeProvider = void 0;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _objss = _interopRequireDefault(require("objss"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Theme = (0, _react.createContext)({});

const useTheme = () => (0, _react.useContext)(Theme);

const ThemeProvider = ({
  children,
  value,
  theme
}) => {
  if (!value && !theme) {
    throw new Error('Must provide either value or theme.');
  } // Support both <ThemeProvider value={...}> and <ThemeProvider theme={...}>
  // (latter being styled-components standard)


  return _react.default.createElement(Theme.Provider, {
    value: value || theme
  }, children);
};

exports.ThemeProvider = ThemeProvider;

const createMediaQuery = (breakpoint, rules) => ({
  styles: _react.default.createElement(_style.default, {
    id: "1317157833",
    dynamic: [breakpoint, (0, _objss.default)(rules)]
  }, "@media (min-width:".concat(breakpoint, "){.__jsx-style-dynamic-selector{").concat((0, _objss.default)(rules), ";}}")),
  className: _style.default.dynamic([["1317157833", [breakpoint, (0, _objss.default)(rules)]]])
});

const styler = (props, opts, theme) => {
  const styleObjects = [];
  const mediaQueries = [];
  opts.forEach(opt => {
    // Disable breakpoint cache because it causes hydration error on SSR
    // TODO: fix this somehow
    const x = opt({ ...props,
      theme: { ...theme,
        disableStyledSystemCache: true
      }
    });
    Object.entries(x).forEach(([key, value]) => {
      if (key.startsWith('@media')) {
        const breakpoint = key.split('@media screen and (min-width: ').pop().replace(')', '');
        const y = createMediaQuery(breakpoint, value);
        mediaQueries.push(y);
      } else {
        // Not a media query, just regular styling
        styleObjects.push({
          [key]: value
        });
      }
    });
  });
  const styles = Object.assign({}, ...styleObjects);
  return [{
    styles: _react.default.createElement(_style.default, {
      id: "4286242976",
      dynamic: [(0, _objss.default)(styles)]
    }, ".__jsx-style-dynamic-selector{".concat((0, _objss.default)(styles), ";}")),
    className: _style.default.dynamic([["4286242976", [(0, _objss.default)(styles)]]])
  }, ...mediaQueries];
};

const HOC = (Component, opts) => {
  const Comp = ({
    className,
    children,
    ...props
  }) => {
    const theme = useTheme();
    const styles = styler(props, opts, theme);
    return _react.default.createElement(Component, _extends({}, props, {
      className: (0, _classnames.default)(className, [...styles.map(s => s.className)])
    }), children, styles.map((s, i) => {
      return _react.default.createElement(_react.default.Fragment, {
        key: "styled-system-".concat(i)
      }, s.styles);
    }));
  };

  return Comp;
};

var _default = HOC;
exports.default = _default;